function translate(x, y, z)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          vertex.x = vertex.x + x
          vertex.y = vertex.y + y
          vertex.z = vertex.z + z
        end
      end
    end
  end
end

-----------------------------------------------------------------------
-- Rotation functions need to be implemented with rotation matricies --
-----------------------------------------------------------------------

function rotateX(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.y = cos * y - sin * z
          vertex.z = sin * y + cos * z
        end
      end
    end
  end
end

function rotateY(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.x = cos * x + sin * z
          vertex.z = -sin * x + cos * z
        end
      end
    end
  end
end

function rotateZ(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.x = cos * x - sin * y
          vertex.y = sin * x + cos * y
        end
      end
    end
  end
end

function Update_Camera(dt)
  if kbd.isDown("w") then
		translate(0, 0, dt)
  end
	if kbd.isDown("s") then
		translate(0, 0, -dt)
  end
	if kbd.isDown("a") then
		translate(dt, 0, 0)
  end
	if kbd.isDown("d") then
		translate(-dt, 0, 0)
	end
	if kbd.isDown("f") then
		rotateX(-dt)
	end
  if kbd.isDown("lctrl") then
		translate(0, -dt, 0)
	end
  if kbd.isDown("e") then
		rotateY(dt)
	end
  if kbd.isDown("q") then
		rotateY(-dt)
	end
	if kbd.isDown(" ") then
		translate(0, dt, 0)
	end
	if kbd.isDown("r") then
		rotateX(dt)
	end
	if kbd.isDown("c") then
		rotateZ(-dt)
	end
	if kbd.isDown("lshift") then
		rotateZ(dt)
	end
end
