local function readVertecies(filename)
	local vertex = 0
	local face = 0
	local object = {}
	object.faces = {}
	object.vertecies = {}

	for line in fsm.lines("_bin/_models/"..filename) do
		if line:match("v%s[-]?%d+%.%d+%s[-]?%d+%.%d+%s[-]?%d+%.%d+") then
			vertex = vertex + 1
			local x, y, z = line:match("([-]?%d+%.*%d*)%s([-]?%d+%.*%d*)%s([-]?%d+%.*%d*)")
			object.vertecies[vertex] = {}
			object.vertecies[vertex].x = x
			object.vertecies[vertex].y = y
			object.vertecies[vertex].z = z
		elseif line:find("f%s[-]?%d+.%d+") then
			face = face + 1
			local f1, f2, f3 = line:match("f%s(%d+)%s(%d+)%s(%d+)")
			object.faces[face] = {f1, f2, f3}
		end
	end

	return object
end

local function loadModels()
	local files = fsm.getDirectoryItems("_bin/_models")
	local models = {}

	for _, object in ipairs(files) do
		if object:match(".obj") then
			vertecies = readVertecies(object)
			models[object:sub(1, -5)] = vertecies
		end
	end

	return models
end

local function addModel(modelname, amount)
	for i = 1, amount do
		objects[#objects + 1] = models[modelname]
	end
end

Model = {
	loadModels = loadModels,
	readVertecies = readVertecies,
	addModel = addModel
}

return Model